(* Atomi mintk *)

(* val le : order -> bool
*)
fun le GREATER = false
  | le EQUAL   = true
  | le LESS    = true;

(* val le : order -> bool
*)
fun le GREATER = false
  | le _       = true;

load "Bool";
(* val neg : bool -> bool
*)
fun neg Bool.false = true
  | neg (true)     = Bool.false;

(* val prod : int list -> int
*)
fun prod [a,b]   = a*b
  | prod [a,b,c] = a*b*c
  | prod [a]     = a
  | prod ()      = 1;

(* Mintasor *)

(* val // : {den : int, num : int} -> real
*)
fun // {den = 0, ...}     = raise Domain
  | // {num = n, den = d} = (real n) / (real d);

(* val // : {den : int, num : int} -> real
*)
fun // {den=0, ...} = raise Domain
  | // {num, den}   = (real num) / (real den);

(* val // : {den : int, num : int} -> real
*)
fun // {den as 0, ...}         = raise Domain
  | // {num as n, den as d} = (real n) / (real d);

(* Minta *)

(* val sum : real list -> real
*)
fun sum []                         = 0.0
  | sum [a : real]                 = a
  | sum (x :: z :: (yxs as y::xs)) = x + z + sum yxs
  | sum (x :: y :: xs)             = x + y + sum xs
  | sum (op::(x, xs))              = x + sum xs;

(* ------------------------------------------------ *)

(* Kitr: pr tpusa, tbbszrs terhels *)

+;
op+;
op+(3, 4);
op+(3.0, 4.0);

(* Kitr: fggvnykompozci
*)

infix 2 o;

(* o : ? * ? -> ?
   f o g = az f s g fggvnyek kompozcija
*)
fun (f o g) x = f(g x);

(* ------------------------------------------------ *)

(* Racionlis szmok
*)

type rat = {num : int, den : int};

val ratZero    = {num = 0, den = 1};
val ratOne     = {num = 1, den = 1};
val ratHalf    = {num = 1, den = 2};
val ratThird   = {num = 1, den = 3};

(* gcd : int -> int -> int
   gcd n m = n s m legnagyobb kzs osztja
*)
fun gcd n 0 = abs n
  | gcd n m = gcd (abs m) (abs(n mod m));

(* normalize : rat -> rat
   normalize r = r normalizlt alakban
*)
fun normalize {num = n, den = 0} = raise Domain
  | normalize {num = n, den = d} = {num = n div (gcd n d), den = d div (gcd n d)}

(* toRat : int -> int -> rat
   toRat n d = n nevezj s d szmllj racionlis szm, normalizlt alakban
*)
fun toRat n d = normalize {num = n, den = d};

(* Racionlis szmok: a ngy alapmvelet
*)

(* **, //, ++, -- : rat * rat -> rat
   r1 ** r2 = az r1 s r2 racionlis szmok szorzata
   r1 // r2 = az r1 s r2 racionlis szmok hnyadosa
   r1 ++ r2 = az r1 s r2 racionlis szmok sszege
   r1 -- r2 = az r1 s r2 racionlis szmok klnbsge
*)

infix 7 ** //; infix 6 ++ --;

fun (r1 : rat) ** (r2 : rat) = toRat (#num r1 * #num r2) (#den r1 * #den r2);

fun (r1 : rat) // (r2 : rat) = toRat (#num r1 * #den r2) (#num r2 * #den r1);

fun {num= n1, den= d1} ++ {num= n2, den= d2} = toRat (n1*d2 + n2*d1) (d1*d2);

fun {num= n1, den= d1} -- {num= n2, den= d2} = toRat (n1*d2 - n2*d1) (d1*d2);

(* Racionlis szmok: relcis mveletek
*)

(* <<=, <<, >>=, >> : rat * rat -> bool
   r1 <<= r2 = igaz, ha r1 nem nagyobb r2-nl
   r1 << r2 = igaz, ha r1 kisebb r2-nl
   r1 >>= r2 = igaz, ha r2 nem nagyobb r1-nl
   r1 >> r2 = igaz, ha r1 nagyobb r2-nl
*)

infix 4 << >> <<= >>=;

fun (r1 : rat) << (r2 : rat) = #num r1 * #den r2 < #num r2 * #den r1;

fun (r1 : rat) >> (r2 : rat) = #num r1 * #den r2 > #num r2 * #den r1;

fun r1 <<= r2 = not(r1 >> r2);

fun r1 >>= r2 = not(r1 << r2);

(* <<= s >>= mskppen
*)

val op<<= = not o op>>;

val op>>= = not o op<<;

load "Int";

(* toString : rat -> string
   toString r = az r racionlis szm fzrknt (szmll/nevez alakban, 
                ha a nevez = 1, egybknt egszknt)
*)
fun toString {num, den = 1} = Int.toString num
  | toString {num, den}     = Int.toString num ^ "/" ^ Int.toString den

(* Pldk a racionlis szmok hasznlatra
*)
normalize (toRat 15 3);
normalize (toRat 15 ~3);
normalize (toRat ~15 3);
normalize (toRat ~15 ~3);

toString(toRat 2 3 ** toRat 5 4);
toString(toRat 2 3 // toRat 5 3);
toString(toRat 1 4 ++ toRat 3 10);
toString(toRat 3 10 -- toRat 1 4);

toRat 2 3 << toRat 5 4;
toRat 2 3 >> toRat 5 3;
toRat 1 4 << toRat 3 10;
toRat 3 10 >> toRat 1 4;

infix 8 /-/;
fun n /-/ d = toRat n d;

toString(2/-/3 **  5/-/4);
toString(2/-/3 //  5/-/3);
toString(1/-/4 ++  3/-/10);
toString(3/-/10 -- 1/-/4);

2/-/3  <<   5/-/4;
2/-/3  <<   2/-/3;
2/-/3  <<=  2/-/3;
2/-/3  >>   5/-/3;
1/-/4  <<   3/-/10;
3/-/10 >>   1/-/4;
3/-/10 >>=  3/-/10;

(* Pldk gcd alkalmazsra s rszleges alkalmazsra
*)
gcd 136 16;
gcd 16 136;
gcd ~136 16;
gcd 136 ~16;
gcd ~136 ~16;
gcd 16 0;
gcd 0 16;
gcd 0 0;
gcd 120;
val gcd120 = gcd 120; (* gcd16 : int -> int *)
gcd120 45;
gcd120 48;
gcd120 ~96;
gcd120 630;
