(* Polimorfizmus *)

(* id : 'a -> 'a
*)
fun id x = x;

(* =, <> : ''a -> ''a -> bool
*)
op=;
op<>;

(* <, >, <=, >= : ? * ? -> bool
*)
op<=;

(* eq : ''a -> ''a -> bool
   eq x y = igaz, ha x = y
*)
fun eq x y = x = y;

(* Pldk eq hasznlatra *)

eq 3 3;
eq "id" "id";
eq id id;

eq 3;
eq "id";
val eqStr_id = eq "id";

(* Pldk id hasznlatra *)

id 3;
id "id";
id round;
id id;
id id 6.9;
fn x => id id x;

(* Nem-expanzv kifejezs - 1 *)

val x = length;

(* Expanzv kifejezs *)

val x = (fn f => f) length;
x ["abc", "def"];
x [123, 456, 789];

(* Nem-expanzv kifejezs - 2 *)

val x1 = fn y => ((fn f => f) length) y;
val x1 = fn y => (fn f => f) length y;
x1 ["abc", "def"];
x1 [123, 456, 789];

(* Listajellsek *)

[];
nil;
op::;

#"" :: nil;
3 :: 5 :: 9 :: nil = 3 :: (5 :: (9 :: nil));

[3, 5, 9] =  3 :: 5 :: 9 :: nil;

(* hd s tl *)

(* hd : 'a list -> 'a 
*)
fun hd (x :: _) = x;

hd [1, 2, 3];
hd [];
List.hd [1, 2, 3];
List.hd [];

(* tl : 'a list -> 'a list 
*)
fun tl (_ :: xs) = xs;

tl [1, 2, 3];
tl [];
List.tl [1, 2, 3];
List.tl [];

(* length, sum, prod *)

(* length : 'a list -> int 
*)
fun length (_ :: xs) = 1 + length xs
  | length []        = 0;

length [1, 2, 3, 4];
length [];
List.length [1, 2, 3, 4];
List.length [];

(* isum : int list -> int 
*)
fun isum (x :: xs) = x + isum xs
  | isum []        = 0;

isum [1, 2, 3, 4];
isum [];

(* rprod : real list -> int 
*)
fun rprod (x :: xs) = x * rprod xs
  | rprod []        = 1.0;

rprod [1.0, 2.0, 3.0, 4.0];
rprod [];

(* map
*)

load "Math";  
map Math.sqrt [1.0, 4.0, 9.0, 16.0] = [1.0, 2.0, 3.0, 4.0];

map;

(* map : ('a -> 'b) -> 'a list -> 'b list
*)
fun map f (x::xs) = f x :: map f xs
  | map f [] = [];

map Math.sqrt;

(* explode, implode *)

explode;

implode;

explode "abc" = [#"a", #"b", #"c"];

implode [#"a", #"b", #"c"] = "abc";

(* filter *)

List.filter Char.isLower (explode "VaLtOgAtVa") = [#"a",#"t",#"g",#"t",#"a"];

List.filter;

fun filter p (x :: xs) = 
      if p x then x :: filter p xs else filter p xs 
  | filter _ [] = [];

filter Char.isLower (explode "VaLtOgAtVa") = [#"a",#"t",#"g",#"t",#"a"];
