(* foldr, foldl alkalmazsa *)

(* isum, rprod *)

foldl op+ 0 [] = 0;
foldl op+ 0 [4] = 4;
foldl op+ 0 [1, 2, 3, 4] = 10;
foldr op* 1.0 [] = 1.0;
foldr op* 1.0 [4.0] = 4.0;
foldr op* 1.0 [1.0, 2.0, 3.0, 4.0] = 24.0;

val isum = foldr op+ 0;
val isum = foldl op+ 0;
val rprod = foldr op+ 1.0;
val rprod = foldl op+ 1.0;

isum [];
isum [4];
isum [1, 2, 3, 4];
rprod [];
rprod [4.0];
rprod [1.0, 2.0, 3.0, 4.0];

(* length *)

(* inc : 'a * int -> int
   inc (_, n) = n + 1
*)
fun inc (_, n) = n + 1;

(* lengthl, lengthr : 'a list -> int
*)
val lengthl = fn ls => foldl inc 0 ls;
fun lengthr ls = foldr inc 0 ls;

lengthl (explode "tengertanc");
lengthr (explode "hajdu sogor");

(* egy lista elemeinek egy msik lista el fzse *)

(* append : 'a list -> 'a list -> 'a list
   append xs ys = az xs ys el fzsvel elll lista
*)
fun append xs ys = foldr op:: ys xs;

append [1,2,3] [4,5,6];

(* revApp : 'a list -> 'a list -> 'a list
   revApp xs ys = a megfordtott xs ys el fzsvel elll lista
*)
fun revApp xs ys = foldl op:: ys xs;

revApp [1,2,3] [4,5,6];

(* foldr, foldl defincija *)

(* foldr : ('a * 'b -> 'b) -> 'b -> 'a list -> 'b
   foldr f e xs = az xs elemeire jobbrl balra haladva alkalmazott,
                  ktoperandus, e egysgelem f mvelet eredmnye
*)
fun foldr f e (x::xs) = f(x, foldr f e xs)
  | foldr f e [] = e;

(* foldl : ('a * 'b -> 'b) -> 'b -> 'a list -> 'b
   foldl f e xs = az xs elemeire balrl jobbra haladva alkalmazott,
                  ktoperandus, e egysgelem f mvelet eredmnye
*)
fun foldl f e (x::xs) = foldl f (f(x, e)) xs
  | foldl f e [] = e;

(* listaelemek klnbsge *)

(* foldL : ('a * 'b -> 'a) -> 'a -> 'b list -> 'a
   foldL f e xs = az xs elemeire balrl jobbra haladva alkalmazott,
                   ktoperandus, e egysgelem f mvelet eredmnye
*)
fun foldL f e (x::xs) = foldL f (f(e, x)) xs
  | foldL f e [] = e;

foldL op- 20 [] = 20;

foldL (op div) 180  [] = 180;

foldL op- 20 [5, 6, 7] = (((20 - 5) - 6) - 7);

foldL (op div) 180  [2, 3, 5] = (((180 div 2) div 3) div 5);

fun subtract ns = foldL op- (hd ns) (tl ns);
subtract [20, 5, 6, 7] = (((20 - 5) - 6) - 7);

fun divide ns = foldL op div (hd ns) (tl ns);
divide [180, 2, 3, 5] = (((180 div 2) div 3) div 5);

fun subtract1 ns = hd ns - foldl op+ 0 (tl ns);
subtract1 [20, 5, 6, 7] = (((20 - 5) - 6) - 7);

fun divide1 ns = hd ns div foldl op* 1 (tl ns);
divide1 [180, 2, 3, 5] = (((180 div 2) div 3) div 5);

(* faktorilis *)

(* fac : int -> int       (-- fontos a klzok sorrendje! --)
   fac n = n!
   PRE n >= 0 *)
fun fac 0 = 1 | fac n = n * fac(n-1);

fac 6;

(* faci : int -> int -> int    (-- fontos a klzok sorrendje! --)
   faci n p = p * n!           (-- p az akkumultor --)
*)
fun faci 0 p = p
  | faci n p = faci (n-1) (n*p);

(* fac : int -> int
   fac n = n!
   PRE n >= 0
*)
fun fac n = faci n 1;

fac 5;

(* loklis deklarci, loklis kifejezs *)

local
    fun faci 0 p = p
      | faci  n p = faci (n-1) (n*p)
in
    fun fac n = faci n 1
end;

fac 7;

fun fac n =
  let
      fun faci 0 p = p
        | faci n p = faci (n-1) (n*p)
  in
      faci n 1
  end;

fac 4;
