(* if-then-else, andalso, orelse : lusta *)

if true then 1 else 2;
if true then 10 div 2 else 9 div 0;
if false then 10 div 2 else 9 div 0;

10 div 2 = 4 andalso 9 div 0 = 3;
10 div 2 = 5 andalso 9 div 0 = 3;
10 div 2 = 5 orelse 9 div 0 = 3;
10 div 2 = 4 orelse 9 div 0 = 3;

(* if true then 10 div 2 else 9 div 0; *)
(fn true => 10 div 2 | false => 9 div 0) true;

(* if false then 10 div 2 else 9 div 0; *)
(fn true => 10 div 2 | false => 9 div 0) false;

fun ifThenElse b = (fn true => 10 div 2 | false => 9 div 0) b;

ifThenElse true;
ifThenElse false;

(* tipikus HIBA !!! *)

if 1 < 2 then true else false = (1 < 2);
if 1 > 2 then true else false = (1 > 2);

(* &&, ||, before : moh *)

(* && (a, b) = a /\ b         
   && : bool * bool -> bool   
*)                            
fun op&& (a, b) = a andalso b;
infix 2 &&;                   

(* || (a, b) = a \/ b         
   || : bool * bool -> bool   
*)                            
fun op|| (a, b) = a orelse b; 
infix 1 ||;                   

10 div 2 = 4 && 9 div 3 = 3;
10 div 2 = 5 && 9 div 3 = 2;
10 div 2 = 4 && 9 div 0 = 3;
10 div 2 = 5 && 9 div 0 = 3;

10 div 2 = 5 || 9 div 3 = 2;
10 div 2 = 4 || 9 div 3 = 3;
10 div 2 = 5 || 9 div 0 = 3;
10 div 2 = 4 || 9 div 0 = 3;

(* before : 'a * 'b -> 'a
   a before b = a 
*)
1 before 2;
10 div 2 before 9 div 3;
10 div 2 before 9 div 0;
10 div 0 before 9 div 3;
10 div 2 before print "10 oszthato 2-vel.\n";

(* append, revApp, @, rev *)

(* append : 'a list * 'a list -> 'a list
*)
fun append (xs, ys) = foldr op:: ys xs;

(* revApp : 'a list * 'a list -> 'a list
*)
fun revApp (xs, ys) = foldl op:: ys xs;

(* rev : 'a list -> 'a list
*)
fun rev xs = foldl op:: [] xs;

(* upto *)

(* upto m n = az [m, n) tartomnyba es egszek listja
   upto : int -> int -> int list
*)
fun upto m n =  if m < n then m :: upto (m+1) n else [];

(* upto m n = az [m, n) tartomnyba es egszek listja
   upto : int -> int -> int list *)
fun upto m n =
      let (* az up szmra az n lland rtk, 
             ezrt nem kell argumentumknt tadni *)
          fun up zs m = if m < n then up (m::zs) (m+1) else rev zs
      in  
          up [] m
      end;

(* upto m n = az [m, n) tartomnyba es egszek listja
   upto : int -> int -> int list *)
fun upto m n =
      let (* htulrl visszafel haladva ptjk fl a listt,
             ezrt a vgn nem kell megfordtani *)
          fun up zs n = if m < n  then up (n-1::zs) (n-1) else zs
      in
          up [] n
      end;

val ms = upto 1 50000;
val ns = upto 1 200000;

rev ms;
rev ns;
List.rev ns;

revApp(ms, ns);
append(ms, ns);

revApp(ns, ms);
append(ns, ms);
revApp(rev ns, ms);
ns @ ms;
List.revAppend(rev ns, ms);

(* lista maximlis eleme (int, generikus) *)

app load ["Int", "Real", "ListPair"];

val is = [4, 8, 6, 7, 4, 19, 13, 6, 19, 7, 3, 4];
val rs = [4.7, 8.9, 6.5, 71.8, 4.5, 19.4, 13.4, 6.2, 9.0, 73.9, 3.0, 4.8];
val cs = explode "asdfghjklZXCVBNERYTUI$%^&%^YTHPO";
val ps = ListPair.zip(is, rs);

(* maxl ns = az ns egszlista legnagyobb eleme
   maxl : int list -> int *)
fun maxl [n] = n
  | maxl (n::ns) = Int.max(n, maxl ns)
  | maxl [] = raise Empty;

maxl is;

(* max egy-egy vltozata char, illetve (int * real) rtkekre *)

fun charMax (n, m) = if ord n > ord m then n else m;

fun pairMax (n as (n1 : int, n2 : real), m as (m1, m2)) = 
      if n1 > m1 orelse n1 = m1 andalso n2 >= m2 then n else m;

(* maxl max ns = az ns lista legnagyobb eleme
   maxl : ('a * 'a -> 'a) -> 'a list -> 'a *)
fun maxl max [n] = n
  | maxl max (n::ns) = max(n, maxl max ns)
  | maxl max [] = raise Empty;

maxl Int.max is;
maxl Real.max rs;
maxl charMax cs;
maxl pairMax ps;

(* Loklis kifejezs hasznlatval *)

fun maxl max ns =
      let fun mxl  [n] = n
            | mxl (n::ns) = max(n, mxl ns)
            | mxl  [] = raise Empty
      in
         mxl ns
      end;

(* Adott szm elem egy lista elejrl s vgrl ({take, drop) *)

(* take (xs, i) = xs, ha i < 0;
         az xs els i db elembl ll lista, ha i >= 0
   take : 'a list * int -> 'a list
*)
fun take (_, 0)     = []
  | take ([], _)    = []
  | take (x::xs, i) = x :: take(xs, i-1);

take([], ~7);
take([] : bool list, 0);
take(upto 1 13, 0);
take(upto 1 13, 8);
take(upto 1 13, ~8);
take(upto 1 13, 17);

List.take([], ~7);         (* Subscript *)
List.take(upto 1 13, 12);
List.take(upto 1 13, 13);  (* Subscript *)

(* drop(xs, i) = xs, ha i < 0;
        az xs els i db elemnek elhagysval elll lista, ha i >= 0
   drop : 'a list * int -> 'a list
*)
fun drop ([], _)    = []
  | drop (x::xs, i) = if i > 0 then drop (xs, i-1) else x::xs;

drop([], ~7);
drop([] : bool list, 0);
drop(upto 1 13, 0);
drop(upto 1 13, 8);
drop(upto 1 13, ~8);
drop(upto 1 13, 17);

List.drop([], ~7);         (* Subscript *)
List.drop(upto 1 13, 12);
List.drop(upto 1 13, 13);  (* Subscript *)

fun take2(xs, i) = rev(drop(rev xs, length xs - i));

take2([], ~7);
take2([] : bool list, 0);
take2(upto 1 13, 0);
take2(upto 1 13, 8);
take2(upto 1 13, ~8);
take2(upto 1 13, 17);

take(upto 1 250000, 200000);
take2(upto 1 250000, 200000);
List.take(upto 1 250000, 200000);

(* concat *)

(* concat xss = az xss-beli listkat egy listba fzi
   concat : 'a list list -> 'a list 
*)
fun concat xss = foldr op@ [] xss;

concat [upto 1 6, upto 9 19, upto 578 599];

List.concat [upto 1 6, upto 9 19, upto 578 599];

(* halmazmveletek *)

(* isMem(x, ys) = x eleme-e ys-nek
   isMem : ''a * ''a list -> bool *)
fun isMem (x, y::ys) = x = y orelse isMem (x, ys)
  | isMem (_, []) = false;
infix isMem;

(* newMem(x, xs) = [x] s xs listaknt brzolt unija
   newMem : ''a * ''a list -> ''a list *)
fun newMem (x, xs) = if x isMem xs then xs else x::xs;

(* setof xs = xs elemeinek listaknt brzolt halmaza
   setof : ''a list -> ''a list *)
fun setof (x::xs) = newMem (x, setof xs)
  | setof []      = [];

(* union(xs, ys) = az xs s ys elemeibl ll halmazok unija
   union : ''a list * ''a list -> ''a list *)
fun union (x::xs, ys) = newMem(x, union(xs, ys))
  | union ([], ys)    = ys;

(* inter(xs, ys) = az xs s ys elemeibl ll halmazok metszete
   inter : ''a list * ''a list -> ''a list *)
fun inter (x::xs, ys) = if x isMem ys then x::inter(xs, ys)
                                      else inter(xs, ys)
  | inter ([], _)     = [];

(* isSubset (xs, ys) = az xs elemeibl ll halmaz rszhalmaza-e
                       az ys elemeibl ll halmaznak
   isSubset : ''a list * ''a list -> bool *)
fun isSubset (x::xs, ys) = (x isMem ys) andalso isSubset(xs, ys)
  | isSubset ([], _)     = true;
infix isSubset;

(* isSetEq(xs, ys) = az xs s ys elemeibl ll halmazok egyenlk-e
   isSetEq : ''a list * ''a list -> bool *)
fun isSetEq (xs, ys) = (xs isSubset ys) andalso (ys isSubset xs);

(* pws(xs, base) = az xs halmaz hatvnyhalmaznak s
                   a base halmaznak az unija
   pws : 'a list * 'a list -> 'a list list *)
fun pws (x::xs, base) = pws(xs, base) @ pws(xs, x::base)
  | pws ([], base) = [base];

(* powerset xs = az xs halmaz hatvnyhalmaza
   powerset : 'a list -> 'a list list *)
fun powerset xs = pws(xs, []);
